//----------------------------------------------------------------------
/*EASTRISING TECHNOLOGY CO,.LTD.*/
// Module    : ER-OLEDM2004-2
// Create    : JAVEN
// Date      : 2023-04-18
// Drive IC  : US2066
// INTERFACE : 8080_8bit
// MCU 	     : STC12C5A60S2
// VDD	     : 5V
//----------------------------------------------------------------------
#include <reg51.h>
#include <intrins.h>

#define	uchar	unsigned char
#define	uint	unsigned int

sbit 	CS=P2^4;
sbit 	RES=P2^3;
sbit 	DC=P2^2;
sbit 	_RW=P2^1;
sbit 	_RD=P2^0;
bit 	log=0;
sbit	int0=P3^2;
#define  DATA_BUS	P1



uchar b[]={0x04,0x0E,0x15,0x04,0x04,0x04,0x04,0x00};/*""*/


uchar code character_string[]=
{
	   "EastRisingTechnologyEastRisingTechnology"
	   "EastRisingTechnologyEastRisingTechnology"
};




uchar code font[]=
{
	0x1f,0x00,0x1f,0x00,0x1f,0x00,0x1f,0x00,
	0x00,0x1f,0x00,0x1f,0x00,0x1f,0x00,0x1f,
	0x15,0x15,0x15,0x15,0x15,0x15,0x15,0x15,
	0x0a,0x0a,0x0a,0x0a,0x0a,0x0a,0x0a,0x0a,
	0x08,0x0f,0x12,0x0f,0x0a,0x1f,0x02,0x02,	//
	0x0f,0x09,0x0f,0x09,0x0f,0x09,0x09,0x13,	//
	0x1f,0x11,0x11,0x1f,0x11,0x11,0x11,0x1F,	//
	0x0C,0x0a,0x11,0x1f,0x09,0x09,0x09,0x13,	//
};



 void Delay1(uint n)
{  
while(n--)
  {_nop_();
	_nop_();
	_nop_();
	_nop_(); 
 	_nop_();
	_nop_();

   }
}


void Step(void) interrupt 0 using 0
{
	Delay1(300);
	if(int0==0)
 // {	while(IE0);
	log=!log;
 // }
   while(!int0);
  return;

}




void Delay(uint n)
{while(n)
 { 
	  n--; Delay1(600);
 }
 	for(;log==1;)
	{

	}

}



void Write_Command(unsigned char cmd)
{
	DC= 0;
  	_nop_();
	CS=0;
	_nop_();
	_RW= 0;	
	_nop_();
	 DATA_BUS=cmd;
 	_nop_();
	_RW=1; 
 	_nop_();
	CS=1;
 	_nop_();		
    DC= 1;
  	_nop_();  	
}


void Write_Data(unsigned char Data)
{
	DC= 1;
  	_nop_();
	CS=0;
	_nop_();
	_RW= 0;	
	_nop_();
	 DATA_BUS=Data;
 	_nop_();
	_RW=1; 
 	_nop_();
	CS=1;
 	_nop_();		
    DC= 1;
  	_nop_();	
}

 

void Write_CGRAM(uchar  a[])
{uchar i=64,k;
	Write_Command(0x40);
	for(k=0;k<64;k++)
	{Write_Data(a[k]);
	}
}

void OLED_CGRAM_Address(uchar CGaddr)
{
	Write_Command(0x28);
	Write_Command(0x40|(CGaddr<<3));
}

void OLED_DDRAM_Address(uchar x,uchar y)
{
	uchar addr=0;
	addr+=x+y*0x20;
	Write_Command(0x28);
	Write_Command(0x80|addr);
}
void OLED_Display_Custom(uchar x,uchar y,uchar CGaddr,uchar symbol[])
{
	uchar i;
	OLED_CGRAM_Address(CGaddr);
	for(i=0;i<8;i++)
	{
		Write_Data(symbol[i]);
	}
	OLED_DDRAM_Address(x,y);
	Write_Data(CGaddr);
}


void OLED_ShowChar(uchar x,uchar y,uchar chr)
{
	OLED_DDRAM_Address(x,y);
	Write_Data(chr);
}


void OLED_ShowString(uchar x,uchar y,uchar *str)
{
	OLED_DDRAM_Address(x,y);
	while(*str!='\0')
	{
		Write_Data(*str++);
	}
}


void OLED_Display_Cursor(uchar x,uchar y,uchar mode,uchar dat)
{
	
	if(dat)
	{
	 OLED_DDRAM_Address(x,y);
	 Write_Command(0x28);	
	 if(mode)
	 {
	  Write_Command(0x0F);
	 }
	 else
	 {		
	  Write_Command(0x0E);
	 }
	}
	else
	{
		Write_Command(0x28);
		Write_Command(0x0C);
	}
}



void OLED_Clear()
{
	Write_Command(0x01);			// Set Clear Display
	Delay(10);
}

 void OLED_Display_Turn(uchar dat)
{
	Write_Command(0x2A);   //RE=1
	if(dat==0)
	{	
		Write_Command(0x06);   // SEG99->SEG0  	 COM0->COM31
	}
	else
	{
		Write_Command(0x05);   // SEG0->SEG99    COM31->COM0
	}

	Write_Command(0x28);
}

void LCD_initialize(void)
{ 
  	 RES=0;
	 Delay(10);
	 RES=1;
	 Delay(10); 	
	 
	 Write_Command(0x2a);  //RE=1
	 Write_Command(0x71);  //Function Selection A
	 Write_Data(0x00);	//Disable internal VDD
	 Write_Command(0x28);  //RE=0,IS=0
	 Write_Command(0x08);  //display OFF

	 Write_Command(0x2a);  //RE=1
	 Write_Command(0x79);  //SD=1  OLED command set is enabled
	 Write_Command(0xD5);  //Set Display Clock Divide Ratio/ Oscillator Frequency 
	 Write_Command(0x70);  
	 Write_Command(0x78);  //SD=0   OLED command set is disabled
	 Write_Command(0x09);  //5-dot font width, black/white inverting of cursor disable, 1-line or 2-line display mode
	 Write_Command(0x06);  //COM0 -> COM31  SEG99 -> SEG0,
	 Write_Command(0x72);  //Function Selection B. Select the character no. of character generator    Select character ROM
	 Write_Data(0x01);  //CGRAOM 248 COGRAM 8   Select  ROM A

	 Write_Command(0x2a);  //RE=1
	 Write_Command(0x79);  //SD=1  OLED command set is enabled
	 Write_Command(0xDA);  //Set SEG Pins Hardware Configuration  
	 Write_Command(0x10);  //Alternative (odd/even) SEG pin configuration, Disable SEG Left/Right remap
	 Write_Command(0xDC);  //Function Selection C  Set VSL & GPIO   
	 Write_Command(0x83);  //Internal VSL  represents GPIO pin HiZ, input disabled (always read as low)
	 Write_Command(0x81);  //Set Contrast Control   
	 Write_Command(0x8F);  
	 Write_Command(0xD9);  //Set Phase Length   
	 Write_Command(0x73);  
	 Write_Command(0xDB);  //Set VCOMH Deselect Level (  
	 Write_Command(0x30);  //0.83 x VCC

	 Write_Command(0x78);  //SD=0   OLED command set is disabled
	 Write_Command(0x28);  //RE=0,IS=0

	 OLED_Clear();  //Clear Display
	 Write_Command(0x80);  //Set DDRAM Address

	 Write_Command(0x0C);
	 Write_Command(0x02); 

}

void Write_DDRAM(uchar a)
{uchar j;
 Write_Command(0x02);
  Delay(10);
 Write_Command(0x80);
	for(j=0;j<40;j++)
	{Write_Data(a);
	}
 Write_Command(0xc0);
	for(j=0;j<40;j++)
	{Write_Data(a);
	}
		Delay(1000);

}



void show_character_string(uchar a[])
{uchar j;
 Write_Command(0x02);
  Delay(10);
 Write_Command(0x80);
 	for(j=0;j<40;j++)
	{Write_Data(a[j]);
	}
 Write_Command(0xc0);
 	for(j=40;j<80;j++)
	{Write_Data(a[j]);
	}

		Delay(1000);
}


void write_CGROM(uchar a)
{uchar j;
 Write_Command(0x02);
  Delay(10);
 Write_Command(0x80);
 	for(j=0;j<40;j++)
	{Write_Data(a);a+=1;
	}
 Write_Command(0xc0);
	for(j=0;j<40;j++)
	{Write_Data(a);a+=1;
	}
		Delay(1000);
}



void main(void)
{	
 /* P1M1=0x00; //Set P1 port as push-pull output
P1M0=0xff;

 P2M1=0x00; //Set P2 port as push-pull output
 P2M0=0xFF;
*/
 
	IE=0x81;
	IP=0x01;
	TCON=0x01;
	int0=1;
	DATA_BUS=0xff;
	P2=0xff;
	LCD_initialize();
	while(1)

	{


  	OLED_Clear();
  	OLED_ShowString(3,0,"ER-OLEDM2004-2");
   	OLED_ShowString(0,1,"-www.buydisplay.com-");
   	OLED_ShowString(0,2,"EasrRisingTechnology");
   	OLED_ShowString(4,3,"hollow world");
//	OLED_Display_Custom(5,1,0x00,b);		 
	Delay(1500);	
	OLED_Display_Turn(1);
   	Delay(1500);
 	OLED_Display_Turn(0);



 	Write_CGRAM(font);
	
	Write_DDRAM(0x1f);	

	show_character_string(character_string);				 

	Write_DDRAM(0);	
	Write_DDRAM(1);
	Write_DDRAM(2);
	Write_DDRAM(3);
	Write_DDRAM(4);	
	Write_DDRAM(5);
	Write_DDRAM(6);
	Write_DDRAM(7);

	write_CGROM(0x30);

 

	}

}






